   PROGRAM



   INCLUDE('ABERROR.INC'),ONCE
   INCLUDE('ABFILE.INC'),ONCE
   INCLUDE('ABUTIL.INC'),ONCE
   INCLUDE('ERRORS.CLW'),ONCE
   INCLUDE('KEYCODES.CLW'),ONCE
   INCLUDE('ABFUZZY.INC'),ONCE

   MAP
     MODULE('MANYTOMANYBROWSE_BC.CLW')
DctInit     PROCEDURE                                      ! Initializes the dictionary definition module
DctKill     PROCEDURE                                      ! Kills the dictionary definition module
     END
!--- Application Global and Exported Procedure Definitions --------------------------------------------
     MODULE('MANYTOMANYBROWSE001.CLW')
Main                   PROCEDURE   !Wizard Application for F:\Clarion\ClarionMag\2014\ManyToMany\ManyToMany.dct
     END
   END

SilentRunning        BYTE(0)                               ! Set true when application is running in 'silent mode'

!region File Declaration
Student              FILE,DRIVER('TOPSPEED'),NAME('Student.tps'),PRE(STU),CREATE,BINDABLE,THREAD !                    
pkStudentID              KEY(STU:StudentID),NOCASE,OPT,PRIMARY !                    
kLastNameFirstName       KEY(STU:LastName,STU:FirstName),DUP,NOCASE !                    
kStudentNumber           KEY(STU:StudentNumber),NOCASE     !                    
Photograph                  BLOB                           !                    
Record                   RECORD,PRE()
StudentID                   LONG                           !                    
StudentNumber               STRING(20)                     !                    
FirstName                   STRING(20)                     !                    
LastName                    STRING(20)                     !                    
Address                     STRING(20)                     !                    
Address2                    STRING(20)                     !                    
City                        STRING(20)                     !                    
State                       STRING(2)                      !                    
Zip                         LONG                           !                    
Telephone                   STRING(12)                     !                    
Major                       LONG                           !                    
GradYear                    LONG                           !                    
                         END
                     END                       

Teacher              FILE,DRIVER('TOPSPEED'),PRE(TEA),CREATE,BINDABLE,THREAD !                    
pkTeacherID              KEY(TEA:TeacherID),NOCASE,PRIMARY !                    
kEmployeeNumber          KEY(TEA:EmployeeNumber),NOCASE    !                    
kLastNameFirstName       KEY(TEA:LastName,TEA:FirstName),DUP,NOCASE !                    
Record                   RECORD,PRE()
TeacherID                   LONG                           !                    
EmployeeNumber              STRING(20)                     !                    
FirstName                   STRING(20)                     !                    
LastName                    STRING(20)                     !                    
Address                     STRING(20)                     !                    
City                        STRING(20)                     !                    
State                       STRING(2)                      !                    
Zip                         LONG                           !                    
Telephone                   STRING(12)                     !                    
Department                  LONG                           !                    
                         END
                     END                       

CourseInstance       FILE,DRIVER('TOPSPEED'),NAME('CourseInstance.tps'),PRE(CLA),CREATE,BINDABLE,THREAD !                    
pkCourseInstanceID       KEY(CLA:CourseInstanceID),NOCASE,PRIMARY !                    
kTeacherID               KEY(CLA:TeacherID),DUP,NOCASE     !                    
kCourseID                KEY(CLA:CourseID),DUP,NOCASE      !                    
Record                   RECORD,PRE()
CourseInstanceID            LONG                           !                    
CourseID                    LONG                           !                    
TeacherID                   LONG                           !                    
StartDate                   DATE                           !                    
EndDate                     DATE                           !                    
                         END
                     END                       

Enrollment           FILE,DRIVER('TOPSPEED'),NAME('Enrollment'),PRE(ENR),CREATE,BINDABLE,THREAD !                    
kStudentIDCourseInstanceID KEY(ENR:StudentID,ENR:CourseInstanceID),NOCASE !                    
Record                   RECORD,PRE()
StudentID                   LONG                           !                    
CourseInstanceID            LONG                           !                    
                         END
                     END                       

Course               FILE,DRIVER('TOPSPEED'),NAME('Course.tps'),PRE(COU),CREATE,BINDABLE,THREAD !                    
pkCourseID               KEY(COU:CourseID),NOCASE,PRIMARY  !                    
kCourseNumber            KEY(COU:CourseNumber),NOCASE      !                    
kTitle                   KEY(COU:Title),NOCASE             !                    
Description                 MEMO(1000)                     !                    
Record                   RECORD,PRE()
CourseID                    LONG                           !                    
CourseNumber                STRING(20)                     !                    
Title                       STRING(40)                     !                    
                         END
                     END                       

!endregion

Access:Student       &FileManager,THREAD                   ! FileManager for Student
Relate:Student       &RelationManager,THREAD               ! RelationManager for Student
Access:Teacher       &FileManager,THREAD                   ! FileManager for Teacher
Relate:Teacher       &RelationManager,THREAD               ! RelationManager for Teacher
Access:CourseInstance &FileManager,THREAD                  ! FileManager for CourseInstance
Relate:CourseInstance &RelationManager,THREAD              ! RelationManager for CourseInstance
Access:Enrollment    &FileManager,THREAD                   ! FileManager for Enrollment
Relate:Enrollment    &RelationManager,THREAD               ! RelationManager for Enrollment
Access:Course        &FileManager,THREAD                   ! FileManager for Course
Relate:Course        &RelationManager,THREAD               ! RelationManager for Course

FuzzyMatcher         FuzzyClass                            ! Global fuzzy matcher
GlobalErrorStatus    ErrorStatusClass,THREAD
GlobalErrors         ErrorClass                            ! Global error manager
INIMgr               INIClass                              ! Global non-volatile storage manager
GlobalRequest        BYTE(0),THREAD                        ! Set when a browse calls a form, to let it know action to perform
GlobalResponse       BYTE(0),THREAD                        ! Set to the response from the form
VCRRequest           LONG(0),THREAD                        ! Set to the request from the VCR buttons

Dictionary           CLASS,THREAD
Construct              PROCEDURE
Destruct               PROCEDURE
                     END


  CODE
  GlobalErrors.Init(GlobalErrorStatus)
  FuzzyMatcher.Init                                        ! Initilaize the browse 'fuzzy matcher'
  FuzzyMatcher.SetOption(MatchOption:NoCase, 1)            ! Configure case matching
  FuzzyMatcher.SetOption(MatchOption:WordOnly, 0)          ! Configure 'word only' matching
  INIMgr.Init('.\ManyToManyBrowse.INI', NVD_INI)           ! Configure INIManager to use INI file
  DctInit
  Main
  INIMgr.Update
  INIMgr.Kill                                              ! Destroy INI manager
  FuzzyMatcher.Kill                                        ! Destroy fuzzy matcher


Dictionary.Construct PROCEDURE

  CODE
  IF THREAD()<>1
     DctInit()
  END


Dictionary.Destruct PROCEDURE

  CODE
  DctKill()

