  MEMBER('ManyToMany.clw')

  INCLUDE('ABFILE.INC'),ONCE

  MAP
ManyToMany_BC0:DctInit    PROCEDURE
ManyToMany_BC0:DctKill    PROCEDURE
ManyToMany_BC0:FilesInit  PROCEDURE
  END

Hide:Access:Student  CLASS(FileManager),TYPE               ! FileManager for Student
Init                   PROCEDURE(),DERIVED
Kill                   PROCEDURE(),DERIVED
UseFile                PROCEDURE(BYTE UseType = UseType:Uses),BYTE,PROC,DERIVED
                     END


Hide:Relate:Student  CLASS(RelationManager),TYPE           ! RelationManager for Student
Init                   PROCEDURE
DeferedAddRelations    PROCEDURE(),DERIVED
Kill                   PROCEDURE(),DERIVED
                     END

Hide:Access:Teacher  CLASS(FileManager),TYPE               ! FileManager for Teacher
Init                   PROCEDURE(),DERIVED
Kill                   PROCEDURE(),DERIVED
UseFile                PROCEDURE(BYTE UseType = UseType:Uses),BYTE,PROC,DERIVED
                     END


Hide:Relate:Teacher  CLASS(RelationManager),TYPE           ! RelationManager for Teacher
Init                   PROCEDURE
DeferedAddRelations    PROCEDURE(),DERIVED
Kill                   PROCEDURE(),DERIVED
                     END

Hide:Access:CourseInstance CLASS(FileManager),TYPE         ! FileManager for CourseInstance
Init                   PROCEDURE(),DERIVED
Kill                   PROCEDURE(),DERIVED
UseFile                PROCEDURE(BYTE UseType = UseType:Uses),BYTE,PROC,DERIVED
                     END


Hide:Relate:CourseInstance CLASS(RelationManager),TYPE     ! RelationManager for CourseInstance
Init                   PROCEDURE
DeferedAddRelations    PROCEDURE(),DERIVED
Kill                   PROCEDURE(),DERIVED
                     END

Hide:Access:Enrollment CLASS(FileManager),TYPE             ! FileManager for Enrollment
Init                   PROCEDURE(),DERIVED
Kill                   PROCEDURE(),DERIVED
UseFile                PROCEDURE(BYTE UseType = UseType:Uses),BYTE,PROC,DERIVED
                     END


Hide:Relate:Enrollment CLASS(RelationManager),TYPE         ! RelationManager for Enrollment
Init                   PROCEDURE
DeferedAddRelations    PROCEDURE(),DERIVED
Kill                   PROCEDURE(),DERIVED
                     END

Hide:Access:Course   CLASS(FileManager),TYPE               ! FileManager for Course
BindFields             PROCEDURE(),DERIVED
Init                   PROCEDURE(),DERIVED
Kill                   PROCEDURE(),DERIVED
UseFile                PROCEDURE(BYTE UseType = UseType:Uses),BYTE,PROC,DERIVED
                     END


Hide:Relate:Course   CLASS(RelationManager),TYPE           ! RelationManager for Course
Init                   PROCEDURE
DeferedAddRelations    PROCEDURE(),DERIVED
Kill                   PROCEDURE(),DERIVED
                     END


_Hide:Access:Student &Hide:Access:Student,AUTO,THREAD
_Hide:Relate:Student &Hide:Relate:Student,AUTO,THREAD
_Hide:Access:Teacher &Hide:Access:Teacher,AUTO,THREAD
_Hide:Relate:Teacher &Hide:Relate:Teacher,AUTO,THREAD
_Hide:Access:CourseInstance &Hide:Access:CourseInstance,AUTO,THREAD
_Hide:Relate:CourseInstance &Hide:Relate:CourseInstance,AUTO,THREAD
_Hide:Access:Enrollment &Hide:Access:Enrollment,AUTO,THREAD
_Hide:Relate:Enrollment &Hide:Relate:Enrollment,AUTO,THREAD
_Hide:Access:Course  &Hide:Access:Course,AUTO,THREAD
_Hide:Relate:Course  &Hide:Relate:Course,AUTO,THREAD


ManyToMany_BC0:DctInit PROCEDURE
  CODE
  _Hide:Access:Student &= NEW(Hide:Access:Student)
  _Hide:Relate:Student &= NEW(Hide:Relate:Student)
  _Hide:Access:Teacher &= NEW(Hide:Access:Teacher)
  _Hide:Relate:Teacher &= NEW(Hide:Relate:Teacher)
  _Hide:Access:CourseInstance &= NEW(Hide:Access:CourseInstance)
  _Hide:Relate:CourseInstance &= NEW(Hide:Relate:CourseInstance)
  _Hide:Access:Enrollment &= NEW(Hide:Access:Enrollment)
  _Hide:Relate:Enrollment &= NEW(Hide:Relate:Enrollment)
  _Hide:Access:Course &= NEW(Hide:Access:Course)
  _Hide:Relate:Course &= NEW(Hide:Relate:Course)
  Relate:Student &= _Hide:Relate:Student
  Relate:Teacher &= _Hide:Relate:Teacher
  Relate:CourseInstance &= _Hide:Relate:CourseInstance
  Relate:Enrollment &= _Hide:Relate:Enrollment
  Relate:Course &= _Hide:Relate:Course


ManyToMany_BC0:FilesInit PROCEDURE
  CODE
  _Hide:Relate:Student.Init
  _Hide:Relate:Teacher.Init
  _Hide:Relate:CourseInstance.Init
  _Hide:Relate:Enrollment.Init
  _Hide:Relate:Course.Init


ManyToMany_BC0:DctKill PROCEDURE
  CODE
  _Hide:Relate:Student.Kill
  DISPOSE(_Hide:Relate:Student)
  _Hide:Relate:Teacher.Kill
  DISPOSE(_Hide:Relate:Teacher)
  _Hide:Relate:CourseInstance.Kill
  DISPOSE(_Hide:Relate:CourseInstance)
  _Hide:Relate:Enrollment.Kill
  DISPOSE(_Hide:Relate:Enrollment)
  _Hide:Relate:Course.Kill
  DISPOSE(_Hide:Relate:Course)


Hide:Relate:Student.Init PROCEDURE
  CODE
  _Hide:Access:Student.Init
  SELF.Init(Access:Student,1)


Hide:Access:Student.Init PROCEDURE

  CODE
  SELF.Initialized = False
  SELF.Buffer &= STU:Record
  SELF.FileNameValue = 'Student'
  SELF.SetErrors(GlobalErrors)
  SELF.File &= Student
  PARENT.Init
  Access:Student &= SELF


Hide:Access:Student.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:Student &= NULL                                   ! File manager has been destroyed to assign null, it is an error to reference this after this point


Hide:Access:Student.UseFile PROCEDURE(BYTE UseType = UseType:Uses)

ReturnValue          BYTE,AUTO

  CODE
  IF UseType ~= UseType:Initialize
    SELF.UseFile(UseType:Initialize)                       !Recursive call to ensure initialization takes place
  END
  IF UseType = UseType:Initialize AND ~SELF.Initialized
    SELF.InUseFile = True
    SELF.Init(Student,GlobalErrors)
    SELF.Create = 1
    SELF.LockRecover = 10
    SELF.AddKey(STU:pkStudentID,'STU:pkStudentID',0)
    SELF.AddKey(STU:kLastNameFirstName,'STU:kLastNameFirstName',0)
    SELF.AddKey(STU:kStudentNumber,'STU:kStudentNumber',0)
  END
                                                           !SELF.InUseFile will be set to False in PARENT
  ReturnValue = PARENT.UseFile(UseType)
  RETURN ReturnValue


Hide:Relate:Student.DeferedAddRelations PROCEDURE

  CODE
  DO AddRelations_1
  
  PARENT.DeferedAddRelations

AddRelations_1 ROUTINE
  SELF.AddRelation(Relate:Enrollment,RI:CASCADE,RI:RESTRICT,ENR:kStudentIDCourseInstanceID)
  SELF.AddRelationLink(STU:StudentNumber,ENR:StudentID)


Hide:Relate:Student.Kill PROCEDURE

  CODE
  _Hide:Access:Student.Kill                                ! Kill the file manager
  PARENT.Kill
  Relate:Student &= NULL                                   ! Assign NULL to the RelationManager's FileManager reference, it is an error to reference this after this point
  DISPOSE(_Hide:Access:Student)                            ! destroy the file manager


Hide:Relate:Teacher.Init PROCEDURE
  CODE
  _Hide:Access:Teacher.Init
  SELF.Init(Access:Teacher,1)


Hide:Access:Teacher.Init PROCEDURE

  CODE
  SELF.Initialized = False
  SELF.Buffer &= TEA:Record
  SELF.FileNameValue = 'Teacher'
  SELF.SetErrors(GlobalErrors)
  SELF.File &= Teacher
  PARENT.Init
  Access:Teacher &= SELF


Hide:Access:Teacher.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:Teacher &= NULL                                   ! File manager has been destroyed to assign null, it is an error to reference this after this point


Hide:Access:Teacher.UseFile PROCEDURE(BYTE UseType = UseType:Uses)

ReturnValue          BYTE,AUTO

  CODE
  IF UseType ~= UseType:Initialize
    SELF.UseFile(UseType:Initialize)                       !Recursive call to ensure initialization takes place
  END
  IF UseType = UseType:Initialize AND ~SELF.Initialized
    SELF.InUseFile = True
    SELF.Init(Teacher,GlobalErrors)
    SELF.Create = 1
    SELF.LockRecover = 10
    SELF.AddKey(TEA:pkTeacherID,'TEA:pkTeacherID',1)
    SELF.AddKey(TEA:kEmployeeNumber,'TEA:kEmployeeNumber',0)
    SELF.AddKey(TEA:kLastNameFirstName,'TEA:kLastNameFirstName',0)
  END
                                                           !SELF.InUseFile will be set to False in PARENT
  ReturnValue = PARENT.UseFile(UseType)
  RETURN ReturnValue


Hide:Relate:Teacher.DeferedAddRelations PROCEDURE

  CODE
  DO AddRelations_1
  
  PARENT.DeferedAddRelations

AddRelations_1 ROUTINE
  SELF.AddRelation(Relate:CourseInstance,RI:None,RI:None,CLA:kTeacherID)
  SELF.AddRelationLink(TEA:TeacherID,CLA:TeacherID)


Hide:Relate:Teacher.Kill PROCEDURE

  CODE
  _Hide:Access:Teacher.Kill                                ! Kill the file manager
  PARENT.Kill
  Relate:Teacher &= NULL                                   ! Assign NULL to the RelationManager's FileManager reference, it is an error to reference this after this point
  DISPOSE(_Hide:Access:Teacher)                            ! destroy the file manager


Hide:Relate:CourseInstance.Init PROCEDURE
  CODE
  _Hide:Access:CourseInstance.Init
  SELF.Init(Access:CourseInstance,1)


Hide:Access:CourseInstance.Init PROCEDURE

  CODE
  SELF.Initialized = False
  SELF.Buffer &= CLA:Record
  SELF.FileNameValue = 'CourseInstance'
  SELF.SetErrors(GlobalErrors)
  SELF.File &= CourseInstance
  PARENT.Init
  Access:CourseInstance &= SELF


Hide:Access:CourseInstance.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:CourseInstance &= NULL                            ! File manager has been destroyed to assign null, it is an error to reference this after this point


Hide:Access:CourseInstance.UseFile PROCEDURE(BYTE UseType = UseType:Uses)

ReturnValue          BYTE,AUTO

  CODE
  IF UseType ~= UseType:Initialize
    SELF.UseFile(UseType:Initialize)                       !Recursive call to ensure initialization takes place
  END
  IF UseType = UseType:Initialize AND ~SELF.Initialized
    SELF.InUseFile = True
    SELF.Init(CourseInstance,GlobalErrors)
    SELF.Create = 1
    SELF.LockRecover = 10
    SELF.AddKey(CLA:pkCourseInstanceID,'CLA:pkCourseInstanceID',1)
    SELF.AddKey(CLA:kTeacherID,'CLA:kTeacherID',0)
    SELF.AddKey(CLA:kCourseID,'CLA:kCourseID',0)
  END
                                                           !SELF.InUseFile will be set to False in PARENT
  ReturnValue = PARENT.UseFile(UseType)
  RETURN ReturnValue


Hide:Relate:CourseInstance.DeferedAddRelations PROCEDURE

  CODE
  DO AddRelations_1
  
  PARENT.DeferedAddRelations

AddRelations_1 ROUTINE
  SELF.AddRelation(Relate:Course)

  SELF.AddRelation(Relate:Teacher)


Hide:Relate:CourseInstance.Kill PROCEDURE

  CODE
  _Hide:Access:CourseInstance.Kill                         ! Kill the file manager
  PARENT.Kill
  Relate:CourseInstance &= NULL                            ! Assign NULL to the RelationManager's FileManager reference, it is an error to reference this after this point
  DISPOSE(_Hide:Access:CourseInstance)                     ! destroy the file manager


Hide:Relate:Enrollment.Init PROCEDURE
  CODE
  _Hide:Access:Enrollment.Init
  SELF.Init(Access:Enrollment,1)


Hide:Access:Enrollment.Init PROCEDURE

  CODE
  SELF.Initialized = False
  SELF.Buffer &= ENR:Record
  SELF.FileNameValue = 'Enrollment'
  SELF.SetErrors(GlobalErrors)
  SELF.File &= Enrollment
  PARENT.Init
  Access:Enrollment &= SELF


Hide:Access:Enrollment.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:Enrollment &= NULL                                ! File manager has been destroyed to assign null, it is an error to reference this after this point


Hide:Access:Enrollment.UseFile PROCEDURE(BYTE UseType = UseType:Uses)

ReturnValue          BYTE,AUTO

  CODE
  IF UseType ~= UseType:Initialize
    SELF.UseFile(UseType:Initialize)                       !Recursive call to ensure initialization takes place
  END
  IF UseType = UseType:Initialize AND ~SELF.Initialized
    SELF.InUseFile = True
    SELF.Init(Enrollment,GlobalErrors)
    SELF.Create = 1
    SELF.LockRecover = 10
    SELF.AddKey(ENR:kStudentIDCourseInstanceID,'ENR:kStudentIDCourseInstanceID',0)
  END
                                                           !SELF.InUseFile will be set to False in PARENT
  ReturnValue = PARENT.UseFile(UseType)
  RETURN ReturnValue


Hide:Relate:Enrollment.DeferedAddRelations PROCEDURE

  CODE
  DO AddRelations_1
  
  PARENT.DeferedAddRelations

AddRelations_1 ROUTINE
  SELF.AddRelation(Relate:Student)


Hide:Relate:Enrollment.Kill PROCEDURE

  CODE
  _Hide:Access:Enrollment.Kill                             ! Kill the file manager
  PARENT.Kill
  Relate:Enrollment &= NULL                                ! Assign NULL to the RelationManager's FileManager reference, it is an error to reference this after this point
  DISPOSE(_Hide:Access:Enrollment)                         ! destroy the file manager


Hide:Relate:Course.Init PROCEDURE
  CODE
  _Hide:Access:Course.Init
  SELF.Init(Access:Course,1)


Hide:Access:Course.BindFields PROCEDURE

  CODE
  PARENT.BindFields
  BIND('COU:Description',COU:Description)                  ! Bind memo field


Hide:Access:Course.Init PROCEDURE

  CODE
  SELF.Initialized = False
  SELF.Buffer &= COU:Record
  SELF.FileNameValue = 'Course'
  SELF.SetErrors(GlobalErrors)
  SELF.File &= Course
  PARENT.Init
  Access:Course &= SELF


Hide:Access:Course.Kill PROCEDURE

  CODE
  PARENT.Kill
  Access:Course &= NULL                                    ! File manager has been destroyed to assign null, it is an error to reference this after this point


Hide:Access:Course.UseFile PROCEDURE(BYTE UseType = UseType:Uses)

ReturnValue          BYTE,AUTO

  CODE
  IF UseType ~= UseType:Initialize
    SELF.UseFile(UseType:Initialize)                       !Recursive call to ensure initialization takes place
  END
  IF UseType = UseType:Initialize AND ~SELF.Initialized
    SELF.InUseFile = True
    SELF.Init(Course,GlobalErrors)
    SELF.Create = 1
    SELF.LockRecover = 10
    SELF.AddKey(COU:pkCourseID,'COU:pkCourseID',1)
    SELF.AddKey(COU:kCourseNumber,'COU:kCourseNumber',0)
    SELF.AddKey(COU:kTitle,'COU:kTitle',0)
  END
                                                           !SELF.InUseFile will be set to False in PARENT
  ReturnValue = PARENT.UseFile(UseType)
  RETURN ReturnValue


Hide:Relate:Course.DeferedAddRelations PROCEDURE

  CODE
  DO AddRelations_1
  
  PARENT.DeferedAddRelations

AddRelations_1 ROUTINE
  SELF.AddRelation(Relate:CourseInstance,RI:None,RI:None,CLA:kCourseID)
  SELF.AddRelationLink(COU:CourseID,CLA:CourseID)


Hide:Relate:Course.Kill PROCEDURE

  CODE
  _Hide:Access:Course.Kill                                 ! Kill the file manager
  PARENT.Kill
  Relate:Course &= NULL                                    ! Assign NULL to the RelationManager's FileManager reference, it is an error to reference this after this point
  DISPOSE(_Hide:Access:Course)                             ! destroy the file manager

